ConRO.Warrior = {};
ConRO.Warrior.CheckTalents = function()
end
local ConRO_Warrior, ids = ...;

function ConRO:EnableRotationModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Warrior.CheckTalents;
	if mode == 1 then
		self.Description = 'Warrior [Arms - Melee]';
		self.NextSpell = ConRO.Warrior.Arms;
		self.ToggleDamage();
	end;
	if mode == 2 then
		self.Description = 'Warrior [Fury - Melee]';
		self.NextSpell = ConRO.Warrior.Fury;
		self.ToggleDamage();
	end;
	if mode == 3 then
		self.Description = 'Warrior [Protection - Tank]';
		self.NextSpell = ConRO.Warrior.Protection;
		self.ToggleHealer();
	end;
	self:RegisterEvent('UNIT_SPELLCAST_SUCCEEDED');
	self.lastSpellId = 0;	
end

function ConRO:EnableDefenseModule(mode)
	mode = mode or 1;
	self.ModuleOnEnable = ConRO.Warrior.CheckTalents;
	if mode == 1 then
		self.NextDef = ConRO.Warrior.ArmsDef;
	end;
	if mode == 2 then
		self.NextDef = ConRO.Warrior.FuryDef;
	end;
	if mode == 3 then
		self.NextDef = ConRO.Warrior.ProtectionDef;
	end;
end

function ConRO:UNIT_SPELLCAST_SUCCEEDED(event, unitID, lineID, spellID)
	if unitID == 'player' then
		self.lastSpellId = spellID;
	end
end

function ConRO.Warrior.Arms(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities	
	local pummel											= ConRO:AbilityReady(ids.Arms_Ability.Pummel, timeShift);
	local bshout											= ConRO:AbilityReady(ids.Arms_Ability.BattleShout, timeShift);
	local hthrow											= ConRO:AbilityReady(ids.Arms_Ability.HeroicThrow, timeShift);	
	local csmash, csCD										= ConRO:AbilityReady(ids.Arms_Ability.ColossusSmash, timeShift);
		local csDebuff											= ConRO:TargetAura(ids.Arms_Debuff.ColossusSmash, timeShift);
	local mstrike											= ConRO:AbilityReady(ids.Arms_Ability.MortalStrike, timeShift);
		local dwDebuff											= ConRO:TargetAura(ids.Arms_Debuff.DeepWounds, timeShift + 4);
	local charge 											= ConRO:AbilityReady(ids.Arms_Ability.Charge, timeShift);
		local inChRange 										= ConRO:IsSpellInRange(ids.Arms_Ability.Charge, 'target');
	local slam 												= ConRO:AbilityReady(ids.Arms_Ability.Slam, timeShift);
	local ww 												= ConRO:AbilityReady(ids.Arms_Ability.Whirlwind, timeShift);
	local bstorm, _BladestormCD									= ConRO:AbilityReady(ids.Arms_Ability.Bladestorm, timeShift);
	local exe												= ConRO:AbilityReady(ids.Arms_Ability.Execute, timeShift);
		local mexeCD 											= ConRO:Cooldown(ids.Arms_Talent.MassacreExecute, timeShift);
		local sdBuff											= ConRO:Aura(ids.Arms_Buff.SuddenDeath, timeShift);
	local opower											= ConRO:AbilityReady(ids.Arms_Ability.Overpower, timeShift);
		local opCharges											= ConRO:SpellCharges(ids.Arms_Ability.Overpower);
		local opBuff, opBCount									= ConRO:Aura(ids.Arms_Buff.Overpower, timeShift);
	local sstrikes											= ConRO:AbilityReady(ids.Arms_Ability.SweepingStrikes, timeShift);
		local ssBuff											= ConRO:Aura(ids.Arms_Buff.SweepingStrikes, timeShift);
	local _ShatteringThrowRDY 								= ConRO:AbilityReady(ids.Arms_Ability.ShatteringThrow, timeShift);	
		local _IceBlockBUFF 									= ConRO:UnitAura(45438, timeShift, 'target', 'HELPFUL');
		local _DivineShieldBUFF									= ConRO:UnitAura(642, timeShift, 'target', 'HELPFUL');
		
	local ssplit											= ConRO:AbilityReady(ids.Arms_Talent.Skullsplitter, timeShift);
	local sbolt												= ConRO:AbilityReady(ids.Arms_Talent.StormBolt, timeShift);
	local wbreaker, wbCD									= ConRO:AbilityReady(ids.Arms_Talent.Warbreaker, timeShift);
	local cleave 											= ConRO:AbilityReady(ids.Arms_Talent.Cleave, timeShift);
	local avatar 											= ConRO:AbilityReady(ids.Arms_Talent.Avatar, timeShift);
	local dcalm 											= ConRO:AbilityReady(ids.Arms_Talent.DeadlyCalm, timeShift);
	local rend 												= ConRO:AbilityReady(ids.Arms_Talent.Rend, timeShift);
		local rDebuff											= ConRO:TargetAura(ids.Arms_Debuff.Rend, timeShift + 4);
	local ravager											= ConRO:AbilityReady(ids.Arms_Talent.Ravager, timeShift);

	local _AncientAftershock_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.AncientAftershock, timeShift);
	local _Condemn_CD										= ConRO:Cooldown(ids.Covenant_Ability.Condemn, timeShift);
		local _CondemnMassacre_CD								= ConRO:Cooldown(ids.Covenant_Ability.CondemnMassacre, timeShift);	
	local _ConquerorsBanner_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ConquerorsBanner, timeShift);
	local _SpearofBastion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.SpearofBastion, timeShift);
	
--Conditions	
	local targetPh 											= ConRO:PercentHealth('target');
	local canExe											= targetPh <= 25;
	local Close 											= CheckInteractDistance("target", 3);
	local tarInMelee										= ConRO:Targets(ids.Arms_Ability.Pummel);
	local incombat 											= UnitAffectingCombat('player');
	
	local castExecute = ids.Arms_Ability.Execute;
		if tChosen[ids.Arms_Talent.Massacre] then
			canExe = targetPh <= 35;
			exe = exe and mexeCD <= 0;
			castExecute = ids.Arms_Talent.MassacreExecute;
		end

		if C_Covenants.GetActiveCovenantID() == 2 then
			canExe = canExe or targetPh >= 80;
			if tChosen[ids.Arms_Talent.Massacre] then
				exe = exe and _CondemnMassacre_CD <= 0;
				castExecute = ids.Covenant_Ability.CondemnMassacre;
			else
				exe = exe and _Condemn_CD <= 0;
				castExecute = ids.Covenant_Ability.Condemn;
			end
		end
		
--Indicators		
	ConRO:AbilityInterrupt(ids.Arms_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Arms_Ability.ShatteringThrow, _ShatteringThrowRDY and (_IceBlockBUFF or _DivineShieldBUFF));
	ConRO:AbilityRaidBuffs(ids.Arms_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Arms_Ability.BattleShout));
	ConRO:AbilityMovement(ids.Arms_Ability.Charge, charge and inChRange);
	
	ConRO:AbilityBurst(ids.Arms_Talent.Avatar, avatar and (csCD < 10 or (tChosen[ids.Arms_Talent.Warbreaker] and wbCD < 10)) and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Arms_Ability.Bladestorm, bstorm and not ssBuff and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Arms_Talent.Ravager, ravager and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Covenant_Ability.ConquerorsBanner, _ConquerorsBanner_RDY and incombat and ConRO_BurstButton:IsVisible());
	
--Warnings	
	
--Rotations	
	if _ConquerorsBanner_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.ConquerorsBanner;
	end
	
	if sstrikes and (not bstorm or _BladestormCD >= 12 or tChosen[ids.Arms_Talent.Ravager]) and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) and ConRO_FullButton:IsVisible() then
		return ids.Arms_Ability.SweepingStrikes;
	end	

	if rend and not rDebuff and not csDebuff and (((ConRO_AutoButton:IsVisible() and tarInMelee <= 1) or ConRO_SingleButton:IsVisible()) or (((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) and (ssBuff or tChosen[ids.Arms_Talent.Cleave]))) then
		return ids.Arms_Talent.Rend;
	end

	if ssplit and rage < 60 then
		return ids.Arms_Talent.Skullsplitter;
	end

	if avatar and ((not tChosen[ids.Arms_Talent.Warbreaker] and csCD < 5) or (tChosen[ids.Arms_Talent.Warbreaker] and wbCD < 5)) and ConRO_FullButton:IsVisible() then
		return ids.Arms_Talent.Avatar;
	end

	if ravager and tChosen[ids.Arms_Talent.Ravager] and ((not tChosen[ids.Arms_Talent.Warbreaker] and csmash) or (tChosen[ids.Arms_Talent.Warbreaker] and wbreaker)) and ConRO_FullButton:IsVisible() then
		return ids.Arms_Talent.Ravager;
	end
	
	if tChosen[ids.Arms_Talent.Warbreaker] then
		if wbreaker then
			return ids.Arms_Talent.Warbreaker;
		end
	else	
		if csmash and (((ConRO_AutoButton:IsVisible() and tarInMelee <= 1) or ConRO_SingleButton:IsVisible()) or (((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) and (ssBuff or tChosen[ids.Arms_Talent.Cleave]))) then
			return ids.Arms_Ability.ColossusSmash;
		end
	end

	if bstorm and csDebuff and  ((ConRO_AutoButton:IsVisible() and tarInMelee >= 4) or ConRO_AoEButton:IsVisible()) and ConRO_FullButton:IsVisible() then
		return ids.Arms_Ability.Bladestorm;
	end

	if dcalm then
		return ids.Arms_Talent.DeadlyCalm;
	end
	
	if cleave and not dwDebuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Arms_Talent.Cleave;
	end

	if mstrike and not dwDebuff and (tarInMelee <= 4 or ConRO_SingleButton:IsVisible()) then
		return ids.Arms_Ability.MortalStrike;
	end

	if opower and ((not canExe and opBCount ~= 2) or canExe or ((ConRO_AutoButton:IsVisible() and tarInMelee >= 4) or ConRO_AoEButton:IsVisible())) then
		return ids.Arms_Ability.Overpower;
	end
	
	if exe and (sdBuff or canExe) then
		return castExecute;
	end

	if _SpearofBastion_RDY then
		return ids.Covenant_Ability.SpearofBastion;
	end	
	
	if _AncientAftershock_RDY then
		return ids.Covenant_Ability.AncientAftershock;
	end

	if mstrike and (tarInMelee <= 4 or ConRO_SingleButton:IsVisible()) then
		return ids.Arms_Ability.MortalStrike;
	end
	
	if bstorm and csDebuff and ConRO_FullButton:IsVisible() then
		return ids.Arms_Ability.Bladestorm;
	end
	
	if slam and not canExe and not tChosen[ids.Arms_Talent.FervorofBattle] and ((ConRO_AutoButton:IsVisible() and tarInMelee <= 1) or ConRO_SingleButton:IsVisible() or ssBuff) and rage >= 50 then
		return ids.Arms_Ability.Slam;
	end
	
	if ww and not canExe and rage >= 60 and (tChosen[ids.Arms_Talent.FervorofBattle] or ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible())) then
		return ids.Arms_Ability.Whirlwind;
	end
return nil;
end

function ConRO.Warrior.ArmsDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);
	
--Abilities	
	local rcry												= ConRO:AbilityReady(ids.Arms_Ability.RallyingCry, timeShift);
	local dbts 												= ConRO:AbilityReady(ids.Arms_Ability.DiebytheSword, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Arms_Ability.VictoryRush, timeShift);
		local vBuff												= ConRO:Aura(ids.Arms_Buff.Victorious, timeShift);
	local ipain 											= ConRO:AbilityReady(ids.Arms_Ability.IgnorePain, timeShift);
		local ipBuff 											= ConRO:Aura(ids.Arms_Buff.IgnorePain, timeShift);
		
	local dstance											= ConRO:AbilityReady(ids.Arms_Talent.DefensiveStance, timeShift);
		local defform											= ConRO:Form(ids.Arms_Form.DefensiveStance);
	local ivic	 											= ConRO:AbilityReady(ids.Arms_Talent.ImpendingVictory, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');

--Rotations	
	if tChosen[ids.Arms_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Arms_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff and playerPh < 100 then	
			return ids.Arms_Ability.VictoryRush;
		end
	end

	if ipain and not ipBuff and playerPh <= 90 and rage >= 70 then
		return ids.Arms_Ability.IgnorePain;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if dbts then
		return ids.Arms_Ability.DiebytheSword;
	end
	
	if rcry then
		return ids.Arms_Ability.RallyingCry;
	end
	
	if dstance and not defform then
		return ids.Arms_Talent.DefensiveStance;
	end	
return nil;
end

function ConRO.Warrior.Fury(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);

--Abilities	
	local bt 												= ConRO:AbilityReady(ids.Fury_Ability.Bloodthirst, timeShift + 0.5);
		local eBuff 											= ConRO:Aura(ids.Fury_Buff.Enrage, timeShift);
	local rb 												= ConRO:AbilityReady(ids.Fury_Ability.RagingBlow, timeShift + 0.5);
		local rbCharges											= ConRO:SpellCharges(ids.Fury_Ability.RagingBlow);		
	local charge 											= ConRO:AbilityReady(ids.Fury_Ability.Charge, timeShift);
		local inChRange 										= ConRO:IsSpellInRange(ids.Fury_Ability.Charge, 'target');
	local pummel 											= ConRO:AbilityReady(ids.Fury_Ability.Pummel, timeShift);
	local ramp 												= ConRO:AbilityReady(ids.Fury_Ability.Rampage, timeShift);
	local exe 												= ConRO:AbilityReady(ids.Fury_Ability.Execute, timeShift);
		local mexeCD 											= ConRO:Cooldown(ids.Fury_Talent.MassacreExecute, timeShift);
		local sdBuff 											= ConRO:Aura(ids.Fury_Buff.SuddenDeath, timeShift);	
	local ww 												= ConRO:AbilityReady(ids.Fury_Ability.Whirlwind, timeShift);
		local wwBuff, wwBCount									= ConRO:Aura(ids.Fury_Buff.Whirlwind, timeShift + 2);
	local bshout											= ConRO:AbilityReady(ids.Fury_Ability.BattleShout, timeShift);	
	local reck, reckCD										= ConRO:AbilityReady(ids.Fury_Ability.Recklessness, timeShift);
		local reckBuff 											= ConRO:Aura(ids.Fury_Buff.Recklessness, timeShift - .5);
	local _ShatteringThrowRDY 								= ConRO:AbilityReady(ids.Fury_Ability.ShatteringThrow, timeShift);	
		local _IceBlockBUFF 									= ConRO:UnitAura(45438, timeShift, 'target', 'HELPFUL');
		local _DivineShieldBUFF									= ConRO:UnitAura(642, timeShift, 'target', 'HELPFUL');
		
	local dr 												= ConRO:AbilityReady(ids.Fury_Talent.DragonRoar, timeShift);
	local bstorm 											= ConRO:AbilityReady(ids.Fury_Talent.Bladestorm, timeShift);
	local sbreaker											= ConRO:AbilityReady(ids.Fury_Talent.Siegebreaker, timeShift);
		local sbDebuff											= ConRO:TargetAura(ids.Fury_Debuff.Siegebreaker, timeShift);
	local onslaughtRDY										= ConRO:AbilityReady(ids.Fury_Talent.Onslaught, timeShift);
		local _BloodbathCD										= ConRO:Cooldown(ids.Fury_Talent.Bloodbath, timeShift);
		local _CrushingBlowCD									= ConRO:Cooldown(ids.Fury_Talent.CrushingBlow, timeShift);

	local _AncientAftershock_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.AncientAftershock, timeShift);
	local _CondemnFury_CD									= ConRO:Cooldown(ids.Covenant_Ability.CondemnFury, timeShift);
		local _CondemnMassacreFury_CD							= ConRO:Cooldown(ids.Covenant_Ability.CondemnMassacreFury, timeShift);	
	local _ConquerorsBanner_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ConquerorsBanner, timeShift);
	local _SpearofBastion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.SpearofBastion, timeShift);
	
--Conditions	
	local targetPh 											= ConRO:PercentHealth('target');
	local canExe											= targetPh <= 25;
	local Close 											= CheckInteractDistance("target", 3);
	local tarInMelee										= ConRO:Targets(ids.Fury_Ability.Pummel);
	local incombat 											= UnitAffectingCombat('player');
	
	local castExecute = ids.Fury_Ability.Execute;
		if tChosen[ids.Fury_Talent.Massacre] then
			canExe = targetPh <= 35;
			exe = exe and mexeCD <= 0;
			castExecute = ids.Fury_Talent.MassacreExecute;
		end
		
		if C_Covenants.GetActiveCovenantID() == 2 then
			canExe = canExe or targetPh >= 80;
			if tChosen[ids.Fury_Talent.Massacre] then
				exe = exe and _CondemnMassacreFury_CD <= 0;
				castExecute = ids.Covenant_Ability.CondemnMassacreFury;
			else
				exe = exe and _CondemnFury_CD <= 0;
				castExecute = ids.Covenant_Ability.CondemnFury;
			end
		end
	
	local cast_Bloodthirst = ids.Fury_Ability.Bloodthirst;
	local cast_RagingBlow = ids.Fury_Ability.RagingBlow;
		if tChosen[ids.Fury_Talent.RecklessAbandon] and reckBuff then
			bt = bt and _BloodbathCD <= 0;
			cast_Bloodthirst = ids.Fury_Talent.Bloodbath;
			
			rb = rb and _CrushingBlowCD <= 0;
			cast_RagingBlow = ids.Fury_Talent.CrushingBlow;
		end

--Indicators	
	ConRO:AbilityInterrupt(ids.Fury_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Fury_Ability.ShatteringThrow, _ShatteringThrowRDY and (_IceBlockBUFF or _DivineShieldBUFF));
	ConRO:AbilityRaidBuffs(ids.Fury_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Fury_Ability.BattleShout));
	ConRO:AbilityMovement(ids.Fury_Ability.Charge, charge and inChRange);
	
	ConRO:AbilityBurst(ids.Fury_Ability.Recklessness, reck and ConRO_BurstButton:IsVisible());
	ConRO:AbilityBurst(ids.Fury_Talent.Bladestorm, bstorm and ConRO_BurstButton:IsVisible());	
	ConRO:AbilityBurst(ids.Covenant_Ability.ConquerorsBanner, _ConquerorsBanner_RDY and incombat and ConRO_BurstButton:IsVisible());
	
--Warnings	


--Rotations		
	if ramp and (not eBuff or reckBuff or rage >= 90) and ((ConRO_AutoButton:IsVisible() and tarInMelee <= 1) or ConRO_SingleButton:IsVisible()) then
		return ids.Fury_Ability.Rampage;
	end
	
	if _ConquerorsBanner_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.ConquerorsBanner;
	end
	
	if bt and not eBuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return cast_Bloodthirst;
	end
	
	if ww and not wwBuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Fury_Ability.Whirlwind;
	end	

	if reck and ConRO_FullButton:IsVisible() then
		return ids.Fury_Ability.Recklessness;
	end	

	if sbreaker and (reckBuff or reckCD >= 20) and ((ConRO_AutoButton:IsVisible() and tarInMelee <= 1) or ConRO_SingleButton:IsVisible()) then
		return ids.Fury_Talent.Siegebreaker;
	end	

	if exe and eBuff and (sdBuff or canExe) then
		return castExecute;
	end

	if _SpearofBastion_RDY and eBuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Covenant_Ability.SpearofBastion;
	end	
	
	if _AncientAftershock_RDY and eBuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Covenant_Ability.AncientAftershock;
	end
	
	if ramp and not eBuff and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Fury_Ability.Rampage;
	end		

	if bstorm and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) and ConRO_FullButton:IsVisible() then
		return ids.Fury_Talent.Bladestorm;
	end

	if dr and ((ConRO_AutoButton:IsVisible() and tarInMelee >= 2) or ConRO_AoEButton:IsVisible()) then
		return ids.Fury_Talent.DragonRoar;
	end

	if onslaughtRDY and eBuff then
		return ids.Fury_Talent.Onslaught;
	end

	if rb and rbCharges >= 2 and eBuff then
		return cast_RagingBlow;
	end
	
	if bt then
		return cast_Bloodthirst;
	end
	
	if dr and eBuff then
		return ids.Fury_Talent.DragonRoar;
	end
	
	if _SpearofBastion_RDY and eBuff then
		return ids.Covenant_Ability.SpearofBastion;
	end	
	
	if _AncientAftershock_RDY and eBuff then
		return ids.Covenant_Ability.AncientAftershock;
	end
		
	if bstorm and eBuff and ConRO_FullButton:IsVisible() then
		return ids.Fury_Talent.Bladestorm;
	end

	if rb then	
		return cast_RagingBlow;
	end
			
	if ww then
		return ids.Fury_Ability.Whirlwind;
	end
return nil;
end

function ConRO.Warrior.FuryDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);
	
--Abilities	
	local rcry 												= ConRO:AbilityReady(ids.Fury_Ability.RallyingCry, timeShift);
	local eregen											= ConRO:AbilityReady(ids.Fury_Ability.EnragedRegeneration, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Fury_Ability.VictoryRush, timeShift);
		local vBuff												= ConRO:Aura(ids.Fury_Buff.Victorious, timeShift);
	local ipain 											= ConRO:AbilityReady(ids.Fury_Ability.IgnorePain, timeShift);
		local ipBuff 											= ConRO:Aura(ids.Fury_Buff.IgnorePain, timeShift);
		
	local ivic	 											= ConRO:AbilityReady(ids.Fury_Talent.ImpendingVictory, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	
--Rotations	
	if tChosen[ids.Fury_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Fury_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff and playerPh < 100 then	
			return ids.Fury_Ability.VictoryRush;
		end
	end

	if ipain and not ipBuff and playerPh <= 90 and rage >= 70 then
		return ids.Fury_Ability.IgnorePain;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if eregen then
		return ids.Fury_Ability.EnragedRegeneration;
	end
		
	if rcry then
		return ids.Fury_Ability.RallyingCry;
	end
	
	return nil;
end

function ConRO.Warrior.Protection(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);

--Racials
	local arctorrent										= ConRO:AbilityReady(ids.Racial.ArcaneTorrent, timeShift);
	
--Abilities	
	local taunt 											= ConRO:AbilityReady(ids.Prot_Ability.Taunt, timeShift);
	local revenge 											= ConRO:AbilityReady(ids.Prot_Ability.Revenge, timeShift);
		local rBuff 											= ConRO:Aura(ids.Prot_Buff.Revenge, timeShift);
	local sslam, ssCD										= ConRO:AbilityReady(ids.Prot_Ability.ShieldSlam, timeShift);
	local tclap												= ConRO:AbilityReady(ids.Prot_Ability.ThunderClap, timeShift);
	local pummel 											= ConRO:AbilityReady(ids.Prot_Ability.Pummel, timeShift);
	local charge 											= ConRO:AbilityReady(ids.Fury_Ability.Charge, timeShift);
		local inChRange 										= ConRO:IsSpellInRange(ids.Fury_Ability.Charge, 'target');
	local devas 											= ConRO:AbilityReady(ids.Prot_Ability.Devastate, timeShift);
	local bshout 											= ConRO:AbilityReady(ids.Prot_Ability.BattleShout, timeShift);	
	local avatar 											= ConRO:AbilityReady(ids.Prot_Ability.Avatar, timeShift);
		local avBuff 											= ConRO:Aura(ids.Prot_Buff.Avatar, timeShift);
	local sw 												= ConRO:AbilityReady(ids.Prot_Ability.Shockwave, timeShift);
	local demoshout											= ConRO:AbilityReady(ids.Prot_Ability.DemoralizingShout, timeShift);
	local sblock 											= ConRO:AbilityReady(ids.Prot_Ability.ShieldBlock, timeShift);
		local sbCharges											= ConRO:SpellCharges(ids.Prot_Ability.ShieldBlock);
		local sbBuff 											= ConRO:Aura(ids.Prot_Buff.ShieldBlock, timeShift);
	local _ExecuteRDY 										= ConRO:AbilityReady(ids.Prot_Ability.Execute, timeShift);
	local _ShatteringThrowRDY 								= ConRO:AbilityReady(ids.Prot_Ability.ShatteringThrow, timeShift);	
		local _IceBlockBUFF 									= ConRO:UnitAura(45438, timeShift, 'target', 'HELPFUL');
		local _DivineShieldBUFF									= ConRO:UnitAura(642, timeShift, 'target', 'HELPFUL');
		
	local _RavagerRDY										= ConRO:AbilityReady(ids.Prot_Talent.Ravager, timeShift);
	local sb 												= ConRO:AbilityReady(ids.Prot_Talent.StormBolt, timeShift);
	local _DragonRoarRDY									= ConRO:AbilityReady(ids.Prot_Talent.DragonRoar, timeShift);	

	local _AncientAftershock_RDY							= ConRO:AbilityReady(ids.Covenant_Ability.AncientAftershock, timeShift);
	local _Condemn_CD										= ConRO:Cooldown(ids.Covenant_Ability.Condemn, timeShift);	
	local _ConquerorsBanner_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.ConquerorsBanner, timeShift);
	local _SpearofBastion_RDY								= ConRO:AbilityReady(ids.Covenant_Ability.SpearofBastion, timeShift);
	
--Conditions	
	local targetPh											= ConRO:PercentHealth('target');
	local Close 											= CheckInteractDistance("target", 3);
	local tarInMelee										= ConRO:Targets(ids.Prot_Ability.Pummel);
	local _Can_Execute										= targetPh <= 20;
		
	local _Use_Execute = ids.Prot_Ability.Execute;
		if C_Covenants.GetActiveCovenantID() == 2 then
			_Can_Execute = _Can_Execute or targetPh >= 80;
			_ExecuteRDY = _ExecuteRDY and _Condemn_CD <= 0;
			_Use_Execute = ids.Covenant_Ability.Condemn;
		end
		
--Indicators		
	ConRO:AbilityInterrupt(ids.Prot_Ability.Pummel, pummel and ConRO:Interrupt());
	ConRO:AbilityPurge(ids.Racial.ArcaneTorrent, arctorrent and Close and ConRO:Purgable());
	ConRO:AbilityPurge(ids.Prot_Ability.ShatteringThrow, _ShatteringThrowRDY and (_IceBlockBUFF or _DivineShieldBUFF));
	ConRO:AbilityRaidBuffs(ids.Prot_Ability.BattleShout, bshout and not ConRO:RaidBuff(ids.Prot_Ability.BattleShout));
	ConRO:AbilityTaunt(ids.Prot_Ability.Taunt, taunt and (not ConRO:InRaid() or (ConRO:InRaid() and ConRO:TarYou())));
	ConRO:AbilityMovement(ids.Prot_Ability.Charge, charge and inChRange);

	ConRO:AbilityBurst(ids.Covenant_Ability.ConquerorsBanner, _ConquerorsBanner_RDY and incombat and ConRO_BurstButton:IsVisible());
	
--Warnings	

--Rotations	
	if avatar then
		return ids.Prot_Ability.Avatar;
	end

	if _SpearofBastion_RDY then
		return ids.Covenant_Ability.SpearofBastion;
	end
	
	if _ConquerorsBanner_RDY and ConRO_FullButton:IsVisible() then
		return ids.Covenant_Ability.ConquerorsBanner;
	end

	if _AncientAftershock_RDY then
		return ids.Covenant_Ability.AncientAftershock;
	end
	
	if demoshout and tChosen[ids.Prot_Talent.BoomingVoice] then
		return ids.Prot_Ability.DemoralizingShout;
	end
	
	if _RavagerRDY then
		return ids.Prot_Talent.Ravager;
	end	

	if _DragonRoarRDY then
		return ids.Prot_Talent.DragonRoar;
	end	

	if revenge and (rBuff or rage >= 60) and tarInMelee >= 2 then
		return ids.Prot_Ability.Revenge;
	end

	if tclap and tarInMelee >= 2 then
		return ids.Prot_Ability.ThunderClap;
	end
	
	if sblock and (sslam or ssCD < 2) and not sbBuff and sbCharges >= 2 then
		return ids.Prot_Ability.ShieldBlock;
	end
	
	if sslam then
		return ids.Prot_Ability.ShieldSlam;
	end	
	
	if tclap and tarInMelee <= 1 then
		return ids.Prot_Ability.ThunderClap;
	end		

	if _ExecuteRDY and rage >= 80 and _Can_Execute then
		return _Use_Execute;
	end
	
	if revenge and rBuff and tarInMelee <= 1 then
		return ids.Prot_Ability.Revenge;
	end		
	
	if devas and not tChosen[ids.Prot_Talent.Devastator] then
		return ids.Prot_Ability.Devastate;
	end
	return nil;
end

function ConRO.Warrior.ProtectionDef(_, timeShift, currentSpell, gcd, tChosen)
--Resources	
	local rage 												= UnitPower('player', Enum.PowerType.Rage);
	local rageMax 											= UnitPowerMax('player', Enum.PowerType.Rage);
	
--Abilities	
	local swall 											= ConRO:AbilityReady(ids.Prot_Ability.ShieldWall, timeShift);
	local sblock											= ConRO:AbilityReady(ids.Prot_Ability.ShieldBlock, timeShift);
		local sbCharges											= ConRO:SpellCharges(ids.Prot_Ability.ShieldBlock);
		local sbBuff 											= ConRO:Aura(ids.Prot_Buff.ShieldBlock, timeShift);
	local lstand 											= ConRO:AbilityReady(ids.Prot_Ability.LastStand, timeShift);
	local dshout											= ConRO:AbilityReady(ids.Prot_Ability.DemoralizingShout, timeShift);
	local vrush 											= ConRO:AbilityReady(ids.Prot_Ability.VictoryRush, timeShift);
		local vBuff 											= ConRO:Aura(ids.Prot_Buff.Victorious, timeShift);
	local ipain 											= ConRO:AbilityReady(ids.Prot_Ability.IgnorePain, timeShift);
		local ipBuff 											= ConRO:Aura(ids.Prot_Buff.IgnorePain, timeShift);
	local sReflection										= ConRO:AbilityReady(ids.Prot_Ability.SpellReflection, timeShift);
		
	local ivic 												= ConRO:AbilityReady(ids.Prot_Talent.ImpendingVictory, timeShift);

	local _Fleshcraft_RDY									= ConRO:AbilityReady(ids.Covenant_Ability.Fleshcraft, timeShift);
	
--Conditions	
	local playerPh 											= ConRO:PercentHealth('player');
	
--Rotations	
	if tChosen[ids.Prot_Talent.ImpendingVictory] then
		if ivic and playerPh <= 80 then	
			return ids.Prot_Talent.ImpendingVictory;
		end
	else
		if vrush and vBuff and playerPh < 100 then	
			return ids.Prot_Ability.VictoryRush;
		end
	end
	
	if sReflection and (ConRO:BossCast() or ConRO:Interrupt()) then
		return ids.Prot_Ability.SpellReflection;
	end
	
	if lstand and playerPh <= 40 then
		return ids.Prot_Ability.LastStand;
	end
	
	if ipain and not ipBuff and playerPh <= 90 and rage >= 70 then
		return ids.Prot_Ability.IgnorePain;
	end
	
	if sblock and sbCharges >= 1 and ConRO:TarYou() then
		return ids.Prot_Ability.ShieldBlock;
	end

	if _Fleshcraft_RDY then
		return ids.Covenant_Ability.Fleshcraft;
	end
	
	if demo then
		return ids.Prot_Ability.DemoralizingShout;
	end
	
	if swall then
		return ids.Prot_Ability.ShieldWall;
	end
	
	return nil;
end
